<?php
function file_get_contents_curl($url) {
    $ch = curl_init();

    curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);       

    $data = curl_exec($ch);
    curl_close($ch);

    return $data;
}

function Thumbnail($url, $width = 150, $height = 150, $filename = false) {

    // download and create gd image
    $image = ImageCreateFromString(file_get_contents_curl($url));

    // calculate resized ratio
    // Note: if $height is set to TRUE then we automatically calculate the height based on the ratio
    //$height = $height === true ? (ImageSY($image) * $width / ImageSX($image)) : $height;

    $w = ImageSX($image);
    $h = ImageSY($image);

    if($w > $h) {
            $new_height =   $height;
            $new_width  =   floor($w * ($new_height / $h));
            $crop_x     =   ceil(($w - $h) / 2);
            $crop_y     =   0;
    }
    else {
            $new_width  =   $width;
            $new_height =   floor( $h * ( $new_width / $w ));
            $crop_x     =   0;
            $crop_y     =   ceil(($h - $w) / 2);
    }

    // create image
    $output = ImageCreateTrueColor($width, $height);

    //support transparent png images
    if(exif_imagetype($url) == IMAGETYPE_PNG) {
        imagealphablending($output, false);
        imagesavealpha($output,true);
        $transparent = imagecolorallocatealpha($output, 255, 255, 255, 127);
        imagefilledrectangle($output, 0, 0, $new_width, $new_height, $transparent);
    }

    ImageCopyResampled($output, $image, 0, 0, $crop_x, $crop_y, $new_width, $new_height, $w, $h);

    // save image
    if($filename) {
        if(exif_imagetype($url) == IMAGETYPE_PNG) {
            imagepng($output, $filename);
        }
        else {
            ImageJPEG($output, $filename, 70);
        }
    }
    else {
        return $output;
    }
}

$url = "https://www.freepnglogos.com/uploads/instagram-logo-png-transparent-0.png";

$image = Thumbnail($url);

if(exif_imagetype($url) == IMAGETYPE_PNG) {
    header( "Content-type: image/png" );
    imagepng($image);
}
else {
    header( "Content-type: image/jpeg" );
    imagejpeg($image);
}
?>